> ## Documentation Index
> Fetch the complete documentation index at: https://developer.rocket.chat/llms.txt
> Use this file to discover all available pages before exploring further.

# Message Others

> Retrieves the messages from any direct message in the server.  For this method to work, navigate to  **Manage > Workspace > Settings > General > REST API > Enable Direct Message History Endpoint** and enable it. 

Permission required: `view-room-administration`.
### Change Log
| Version | Description             |
| ------- | ----------------------- |
| 0.50.0  | Added                   |

## OpenAPI

````json GET /api/v1/dm.messages.others
{
  "openapi": "3.0.0",
  "info": {
    "version": "1.0.0",
    "title": "Messaging"
  },
  "servers": [
    {
      "url": "https://apiexplorer.support.rocket.chat"
    }
  ],
  "tags": [
    {
      "name": "Chat"
    },
    {
      "name": "DM"
    },
    {
      "name": "Auto-Translate"
    }
  ],
  "paths": {
    "/api/v1/dm.messages.others": {
      "get": {
        "tags": [
          "DM"
        ],
        "summary": "Message Others",
        "description": "Retrieves the messages from any direct message in the server.  For this method to work, navigate to  **Manage > Workspace > Settings > General > REST API > Enable Direct Message History Endpoint** and enable it. \n\nPermission required: `view-room-administration`.\n### Change Log\n| Version | Description             |\n| ------- | ----------------------- |\n| 0.50.0  | Added                   |",
        "operationId": "get-api-v1-im.messages.others",
        "parameters": [
          {
            "$ref": "#/components/parameters/Auth-Token"
          },
          {
            "$ref": "#/components/parameters/UserId"
          },
          {
            "$ref": "#/components/parameters/RoomId"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "$ref": "#/components/parameters/count"
          },
          {
            "$ref": "#/components/parameters/sort"
          },
          {
            "$ref": "#/components/parameters/query"
          },
          {
            "$ref": "#/components/parameters/fields"
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "messages": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "_id": {
                            "type": "string"
                          },
                          "rid": {
                            "type": "string"
                          },
                          "msg": {
                            "type": "string"
                          },
                          "ts": {
                            "type": "string"
                          },
                          "u": {
                            "type": "object",
                            "properties": {
                              "_id": {
                                "type": "string"
                              },
                              "username": {
                                "type": "string"
                              }
                            }
                          },
                          "_updatedAt": {
                            "type": "string"
                          },
                          "t": {
                            "type": "string"
                          },
                          "groupable": {
                            "type": "boolean"
                          }
                        }
                      }
                    },
                    "success": {
                      "type": "boolean"
                    }
                  }
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "messages": [
                        {
                          "_id": "AkzpHAvZpdnuchw2a",
                          "rid": "ByehQjC44FwMeiLbX",
                          "msg": "hi",
                          "ts": "2016-12-09T12:50:51.555Z",
                          "u": {
                            "_id": "y65tAmHs93aDChMWu",
                            "username": "testing"
                          },
                          "_updatedAt": "2016-12-09T12:50:51.562Z"
                        },
                        {
                          "_id": "vkLMxcctR4MuTxreF",
                          "t": "uj",
                          "rid": "ByehQjC44FwMeiLbX",
                          "ts": "2016-12-08T15:41:37.73Z",
                          "msg": "testing2",
                          "u": {
                            "_id": "bRtgdhzM6PD9F8pSx",
                            "username": "testing2"
                          },
                          "groupable": "false",
                          "_updatedAt": "2016-12-08T16:03:25.235Z"
                        },
                        {
                          "_id": "bfRW658nEyEBg75rc",
                          "t": "uj",
                          "rid": "ByehQjC44FwMeiLbX",
                          "ts": "2016-12-07T15:47:49.099Z",
                          "msg": "testing",
                          "u": {
                            "_id": "nSYqWzZ4GsKTX4dyK",
                            "username": "testing1"
                          },
                          "groupable": "false",
                          "_updatedAt": "2016-12-07T15:47:49.099Z"
                        },
                        {
                          "_id": "pbuFiGadhRZTKouhB",
                          "t": "uj",
                          "rid": "ByehQjC44FwMeiLbX",
                          "ts": "2016-12-06T17:57:38.635Z",
                          "msg": "testing",
                          "u": {
                            "_id": "y65tAmHs93aDChMWu",
                            "username": "testing"
                          },
                          "groupable": "false",
                          "_updatedAt": "2016-12-06T17:57:38.635Z"
                        }
                      ],
                      "success": "true"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/authorizationError"
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "success": {
                      "type": "boolean"
                    },
                    "error": {
                      "type": "string"
                    },
                    "errorType": {
                      "type": "string"
                    },
                    "details": {
                      "type": "object",
                      "properties": {
                        "route": {
                          "type": "string"
                        }
                      }
                    }
                  }
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "success": "false",
                      "error": "This endpoint is disabled [error-endpoint-disabled]",
                      "errorType": "error-endpoint-disabled",
                      "details": {
                        "route": "/api/v1/dm.messages.others"
                      }
                    }
                  },
                  "Example 2": {
                    "value": {
                      "success": "false",
                      "error": "The parameter \"roomId\" is required [error-roomid-param-not-provided]",
                      "errorType": "error-roomid-param-not-provided"
                    }
                  },
                  "Example 3": {
                    "value": {
                      "success": "false",
                      "error": "No direct message room found by the id of: john [error-room-not-found]",
                      "errorType": "error-room-not-found"
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "parameters": {
      "Auth-Token": {
        "name": "X-Auth-Token",
        "in": "header",
        "description": "The `authToken` of the authenticated user.",
        "required": "true",
        "schema": {
          "type": "string"
        },
        "example": "RScctEHSmLGZGywfIhWyRpyofhKOiMoUIpimhvheU3f"
      },
      "UserId": {
        "name": "X-User-Id",
        "in": "header",
        "description": "The `userId` of the authenticated user.",
        "required": "true",
        "schema": {
          "type": "string"
        },
        "example": "rbAXPnMktTFbNpwtJ"
      },
      "RoomId": {
        "name": "roomId",
        "in": "query",
        "description": "The room ID.",
        "required": "true",
        "schema": {
          "type": "string"
        },
        "example": "6GFJ3tbmHiyHbahmC"
      },
      "offset": {
        "name": "offset",
        "in": "query",
        "description": "Number of items to \"skip\" in the query, i.e. requests return count items, skipping the first offset items. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#pagination) to learn more.",
        "required": "false",
        "schema": {
          "type": "integer"
        },
        "example": "50"
      },
      "count": {
        "name": "count",
        "in": "query",
        "description": "The number of items to return.  Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#pagination) to learn more.",
        "required": "false",
        "schema": {
          "type": "integer"
        },
        "example": "50"
      },
      "sort": {
        "name": "sort",
        "in": "query",
        "description": "List of fields to order by, and in which direction. This is a JSON object, with properties listed in desired order, with values of 1 for ascending, or -1 for descending. For example, `{ \"value\": -1, \"_id\": 1 }`. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#pagination) to learn more.",
        "required": "false",
        "schema": {}
      },
      "query": {
        "name": "query",
        "in": "query",
        "description": "This parameter allows you to use MongoDB query operators to search for specific data. For example, to query users with a name that contains the letter \"g\": query=`{ \"name\": { \"$regex\": \"g\" }}`. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#query-and-fields) to learn more.",
        "required": "false",
        "schema": {}
      },
      "fields": {
        "name": "fields",
        "in": "query",
        "description": "This parameter accepts a JSON object with properties that have a value of 1 or 0 to include or exclude them in the response. For example, to only retrieve the usernames of users: fields=`{ \"username\": 1 }`. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#query-and-fields) to learn more.",
        "required": "false",
        "schema": {
          "type": "string"
        }
      }
    },
    "responses": {
      "authorizationError": {
        "description": "Unauthorized",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "status": {
                  "type": "string"
                },
                "message": {
                  "type": "string"
                }
              }
            },
            "examples": {
              "Authorization Error": {
                "value": {
                  "status": "error",
                  "message": "You must be logged in to do this."
                }
              }
            }
          }
        }
      }
    }
  }
}
````

